/*----- PROTECTED REGION ID(Agilent4uhv.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Agilent4uhv.cpp,v 1.25 2019-04-01 09:14:47 alessio Exp $";
//=============================================================================
//
// file :        Agilent4uhv.cpp
//
// description : C++ source for the Agilent4uhv class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Agilent4uhv are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.25 $
// $Date: 2019-04-01 09:14:47 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Agilent4uhv.h>
#include <Agilent4uhvClass.h>

#define MAX_DEVSTRING_LENGTH 255

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv.cpp

/**
 *  Agilent4uhv class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Model         |  Tango::DevString	Scalar
//  SerialNumber  |  Tango::DevString	Scalar
//  Temperature   |  Tango::DevFloat	Scalar
//  CRCErrors     |  Tango::DevLong	Scalar
//  AutoStart     |  Tango::DevBoolean	Scalar
//================================================================

namespace Agilent4uhv_ns
{
/*----- PROTECTED REGION ID(Agilent4uhv::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::Agilent4uhv()
 *	Description : Constructors for a Tango device
 *                implementing the classAgilent4uhv
 */
//--------------------------------------------------------
Agilent4uhv::Agilent4uhv(Tango::DeviceClass *cl, string &s)
 : Serial2Client(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Agilent4uhv::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::constructor_1
}
//--------------------------------------------------------
Agilent4uhv::Agilent4uhv(Tango::DeviceClass *cl, const char *s)
 : Serial2Client(cl, s)
{
	/*----- PROTECTED REGION ID(Agilent4uhv::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::constructor_2
}
//--------------------------------------------------------
Agilent4uhv::Agilent4uhv(Tango::DeviceClass *cl, const char *s, const char *d)
 : Serial2Client(cl, s, d)
{
	/*----- PROTECTED REGION ID(Agilent4uhv::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Agilent4uhv::delete_device()
{
	DEBUG_STREAM << "Agilent4uhv::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::delete_device) ENABLED START -----*/
	if (worker) {
		worker->stop();
		worker->join(NULL);
	}
	
	//	Delete device allocated objects
	delete attr_Model_read[0];
	delete attr_SerialNumber_read[0];

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::delete_device
	delete[] attr_Model_read;
	delete[] attr_SerialNumber_read;
	delete[] attr_Temperature_read;
	delete[] attr_CRCErrors_read;
	delete[] attr_AutoStart_read;

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		Serial2Client_ns::Serial2Client::delete_device();
	}
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Agilent4uhv::init_device()
{
	DEBUG_STREAM << "Agilent4uhv::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	mandatoryNotDefined = false;
	nchannel = 0;
	odd_channel_quirk = false;
	init_error.clear();
	worker = NULL;
	norm_ops.clear();
	prio_ops.clear();

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::init_device_before
	
	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		Serial2Client_ns::Serial2Client::init_device();
	}

	//	Get the device properties from database
	get_device_property();
	
	attr_Model_read = new Tango::DevString[1];
	attr_SerialNumber_read = new Tango::DevString[1];
	attr_Temperature_read = new Tango::DevFloat[1];
	attr_CRCErrors_read = new Tango::DevLong[1];
	attr_AutoStart_read = new Tango::DevBoolean[1];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Agilent4uhv::init_device) ENABLED START -----*/
	
	// Waiting the device
	int retries = 0;
	while(get_state2() == 9 && retries++ < 5) {
		sleep(1);
	}

	try {
		attr_Model_read[0] = new char[MAX_DEVSTRING_LENGTH];
		attr_SerialNumber_read[0] = new char[MAX_DEVSTRING_LENGTH];
		attr_CRCErrors_read[0] = 0;

		read_Model();
		read_SerialNumber();
		if (strncmp(attr_Model_read[0], "9299010", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299011", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299100", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299101", 7) == 0 ||
				strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
			nchannel = 1;
		} else if (strncmp(attr_Model_read[0], "9299020", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299021", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299200", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299201", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299022", 7) == 0) {

			read_PowerMaxCh1();
			if (PowerMaxX_data["PowerMax1"] == 200)
				odd_channel_quirk = true;

			nchannel = 2;
		} else if (strncmp(attr_Model_read[0], "9299210", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299211", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299212", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299213", 7) == 0) {
			nchannel = 3;
		} else if (strncmp(attr_Model_read[0], "9299400", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299401", 7) == 0 ||
				strncmp(attr_Model_read[0], "9299402", 7) == 0) {
			nchannel = 4;
		} else {
			Tango::Except::throw_exception( "",
					"Unknown model",
					"Agilent4uhv::init_device()");
		}

	
		int pressure_unit;
		read("600", pressure_unit);
		if (pressure_unit != 1)
 			Tango::Except::throw_exception( "",
 					"Pressure unit is wrong",
 					"Agilent4uhv::init_device()");

		if(nchannel >= 1) {
			norm_ops.push_back(&Agilent4uhv::read_HVCh1);
			norm_ops.push_back(&Agilent4uhv::read_DeviceNumberCh1);
			prio_ops.push_back(&Agilent4uhv::read_PressureCh1);
			norm_ops.push_back(&Agilent4uhv::read_PowerMaxCh1);
			norm_ops.push_back(&Agilent4uhv::read_VTargetCh1);
			norm_ops.push_back(&Agilent4uhv::read_IProtectCh1);
			norm_ops.push_back(&Agilent4uhv::read_SetPointCh1);
			norm_ops.push_back(&Agilent4uhv::read_TemperatureCh1);
			norm_ops.push_back(&Agilent4uhv::read_IMeasuredCh1);
			norm_ops.push_back(&Agilent4uhv::read_VMeasuredCh1);
			norm_ops.push_back(&Agilent4uhv::read_ErrorCodeCh1);
		}
		
		if(nchannel >= 2) {
			norm_ops.push_back(&Agilent4uhv::read_HVCh2);
			norm_ops.push_back(&Agilent4uhv::read_DeviceNumberCh2);
			prio_ops.push_back(&Agilent4uhv::read_PressureCh2);
			norm_ops.push_back(&Agilent4uhv::read_PowerMaxCh2);
			norm_ops.push_back(&Agilent4uhv::read_VTargetCh2);
			norm_ops.push_back(&Agilent4uhv::read_IProtectCh1);
			norm_ops.push_back(&Agilent4uhv::read_SetPointCh2);
			norm_ops.push_back(&Agilent4uhv::read_TemperatureCh2);
			norm_ops.push_back(&Agilent4uhv::read_IMeasuredCh2);
			norm_ops.push_back(&Agilent4uhv::read_VMeasuredCh2);
			norm_ops.push_back(&Agilent4uhv::read_ErrorCodeCh2);
		}

		if(nchannel >= 3) {
			norm_ops.push_back(&Agilent4uhv::read_HVCh3);
			norm_ops.push_back(&Agilent4uhv::read_DeviceNumberCh3);
			prio_ops.push_back(&Agilent4uhv::read_PressureCh3);
			norm_ops.push_back(&Agilent4uhv::read_PowerMaxCh3);
			norm_ops.push_back(&Agilent4uhv::read_VTargetCh3);
			norm_ops.push_back(&Agilent4uhv::read_IProtectCh1);
			norm_ops.push_back(&Agilent4uhv::read_SetPointCh3);
			norm_ops.push_back(&Agilent4uhv::read_TemperatureCh3);
			norm_ops.push_back(&Agilent4uhv::read_IMeasuredCh3);
			norm_ops.push_back(&Agilent4uhv::read_VMeasuredCh3);
			norm_ops.push_back(&Agilent4uhv::read_ErrorCodeCh3);
		}
		
		if(nchannel >= 4) {
			norm_ops.push_back(&Agilent4uhv::read_HVCh4);
			norm_ops.push_back(&Agilent4uhv::read_DeviceNumberCh4);
			prio_ops.push_back(&Agilent4uhv::read_PressureCh4);
			norm_ops.push_back(&Agilent4uhv::read_PowerMaxCh4);
			norm_ops.push_back(&Agilent4uhv::read_VTargetCh4);
			norm_ops.push_back(&Agilent4uhv::read_IProtectCh1);
			norm_ops.push_back(&Agilent4uhv::read_SetPointCh4);
			norm_ops.push_back(&Agilent4uhv::read_TemperatureCh4);
			norm_ops.push_back(&Agilent4uhv::read_IMeasuredCh4);
			norm_ops.push_back(&Agilent4uhv::read_VMeasuredCh4);
			norm_ops.push_back(&Agilent4uhv::read_ErrorCodeCh4);
		}

		// Related to all channels
		norm_ops.push_back(&Agilent4uhv::read_FixedStep);
		norm_ops.push_back(&Agilent4uhv::read_AutoStart);
		norm_ops.push_back(&Agilent4uhv::read_Protect);
		norm_ops.push_back(&Agilent4uhv::read_Temperature);
		norm_ops.push_back(&Agilent4uhv::read_StatusSetPoint);
		/* This must be the latest */
		norm_ops.push_back(&Agilent4uhv::read_Status);

		worker = new Agilent4uhvWorker(this);
		worker->start();
	} catch(Tango::DevFailed &e) {
		init_error = "Initialization failed: " + string(e.errors[0].desc);
		ERROR_STREAM << init_error << endl;
		set_state(Tango::UNKNOWN);
		assert(false);
	} catch (...) {
		init_error = "Initialization failed: Unknown error";
		ERROR_STREAM << init_error << endl;
		set_state(Tango::UNKNOWN);
		assert(false);
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Agilent4uhv::get_device_property()
{
	/*----- PROTECTED REGION ID(Agilent4uhv::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("DeviceName"));
	dev_prop.push_back(Tango::DbDatum("PollingPause"));
	dev_prop.push_back(Tango::DbDatum("PollingPeriod"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Agilent4uhvClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Agilent4uhvClass	*ds_class =
			(static_cast<Agilent4uhvClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize DeviceName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  deviceName;
		else {
			//	Try to initialize DeviceName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  deviceName;
		}
		//	And try to extract DeviceName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  deviceName;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize PollingPause from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  pollingPause;
		else {
			//	Try to initialize PollingPause from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  pollingPause;
		}
		//	And try to extract PollingPause value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  pollingPause;

		//	Try to initialize PollingPeriod from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  pollingPeriod;
		else {
			//	Try to initialize PollingPeriod from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  pollingPeriod;
		}
		//	And try to extract PollingPeriod value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  pollingPeriod;

	}

	/*----- PROTECTED REGION ID(Agilent4uhv::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void Agilent4uhv::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		string	status(get_status());
		status += tms.str();
		set_status(status);
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(Agilent4uhv::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Agilent4uhv::always_executed_hook()
{
	DEBUG_STREAM << "Agilent4uhv::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"Agilent4uhv::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Agilent4uhv::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	if (! init_error.empty()) {
		set_state(Tango::UNKNOWN);
		set_status(init_error);
		return;
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Agilent4uhv::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Agilent4uhv::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Agilent4uhv::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Agilent4uhv::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Model related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_Model(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_Model(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_Model) ENABLED START -----*/
	attr.set_value(attr_Model_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_Model
}
//--------------------------------------------------------
/**
 *	Read attribute SerialNumber related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_SerialNumber(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_SerialNumber(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_SerialNumber) ENABLED START -----*/
	attr.set_value(attr_SerialNumber_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_SerialNumber
}
//--------------------------------------------------------
/**
 *	Read attribute Temperature related method
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_Temperature(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_Temperature(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_Temperature) ENABLED START -----*/
	attr.set_value(attr_Temperature_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_Temperature
}
//--------------------------------------------------------
/**
 *	Read attribute CRCErrors related method
 *	Description: CRC Errors
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_CRCErrors(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_CRCErrors(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_CRCErrors) ENABLED START -----*/
	attr.set_value(attr_CRCErrors_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_CRCErrors
}
//--------------------------------------------------------
/**
 *	Read attribute AutoStart related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_AutoStart(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_AutoStart(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_AutoStart) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_AutoStart_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_AutoStart
}
//--------------------------------------------------------
/**
 *	Write attribute AutoStart related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_AutoStart(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_AutoStart(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_AutoStart) ENABLED START -----*/
	
 	check_init_error();

	string newvalue;
 	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
 		if (w_val)
 			newvalue = "1";
 		else
 			newvalue = "0";
 	} else {
 		newvalue = "000000000";
		if (w_val)
			newvalue.push_back('1');
		else
			newvalue.push_back('0');
 	}
 	
 	write("601", newvalue);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_AutoStart
}

//--------------------------------------------------------
/**
 *	Read attribute HVX related method
 *	Description: 
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_HVX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_HVX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevState	*att_value = get_HVX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_HVX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_HVX
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceNumberX related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_DeviceNumberX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_DeviceNumberX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevLong	*att_value = get_DeviceNumberX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_DeviceNumberX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_DeviceNumberX
}
//--------------------------------------------------------
/**
 *	Write attribute DeviceNumberX related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_DeviceNumberX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_DeviceNumberX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevLong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_DeviceNumberX) ENABLED START -----*/

	check_init_error();

	int indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	int newvalue = w_val;

	switch (indexn)
	{
		case 1:
			write("610", newvalue);
			break;
		case 2:
			write("620", newvalue);
			break;
		case 3:
			write("630", newvalue);
			break;
		case 4:
			write("640", newvalue);
			break;
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_DeviceNumberX
}
//--------------------------------------------------------
/**
 *	Read attribute PowerMaxX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_PowerMaxX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_PowerMaxX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevUShort	*att_value = get_PowerMaxX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_PowerMaxX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_PowerMaxX
}
//--------------------------------------------------------
/**
 *	Write attribute PowerMaxX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_PowerMaxX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_PowerMaxX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_PowerMaxX) ENABLED START -----*/

	check_init_error();

	int indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	int newvalue = w_val;

	switch (indexn)
	{
		case 1:
			write("612", newvalue);
			break;
		case 2:
			write("622", newvalue);
			break;
		case 3:
			write("632", newvalue);
			break;
		case 4:
			write("642", newvalue);
			break;
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_PowerMaxX
}
//--------------------------------------------------------
/**
 *	Read attribute VTargetX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_VTargetX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_VTargetX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevUShort	*att_value = get_VTargetX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_VTargetX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_VTargetX
}
//--------------------------------------------------------
/**
 *	Write attribute VTargetX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_VTargetX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_VTargetX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_VTargetX) ENABLED START -----*/

	check_init_error();

	int indexn;	
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	int newvalue = w_val * 1000;

	switch (indexn)
	{
		case 1:
			write("613", newvalue);
			break;
		case 2:
			write("623", newvalue);
			break;
		case 3:
			write("633", newvalue);
			break;
		case 4:
			write("643", newvalue);
			break;
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_VTargetX
}
//--------------------------------------------------------
/**
 *	Read attribute IProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_IProtectX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_IProtectX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevUShort	*att_value = get_IProtectX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_IProtectX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_IProtectX
}
//--------------------------------------------------------
/**
 *	Write attribute IProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_IProtectX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_IProtectX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_IProtectX) ENABLED START -----*/

	check_init_error();

	int indexn;	
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	int newvalue;
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		newvalue = w_val * 1000;
	} else {
		newvalue = w_val;
	}

	switch (indexn)
	{
		case 1:
			write("614", newvalue);
			break;
		case 2:
			write("624", newvalue);
			break;
		case 3:
			write("634", newvalue);
			break;
		case 4:
			write("644", newvalue);
			break;
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_IProtectX
}
//--------------------------------------------------------
/**
 *	Read attribute SetPointX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_SetPointX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_SetPointX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_SetPointX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_SetPointX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_SetPointX
}
//--------------------------------------------------------
/**
 *	Write attribute SetPointX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_SetPointX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_SetPointX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_SetPointX) ENABLED START -----*/

	check_init_error();

	int indexn;	
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	string newvalue;
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		char buffer[ALPHANUMERIC_LENGTH_IPCMINI+1];
		int len = snprintf(buffer, ALPHANUMERIC_LENGTH_IPCMINI+1, "% *.1E", ALPHANUMERIC_LENGTH_IPCMINI, w_val);
		newvalue = string(buffer, len);
	} else {
		char buffer[ALPHANUMERIC_LENGTH_4UHV+1];
		int len = snprintf(buffer, ALPHANUMERIC_LENGTH_4UHV+1, "% *.1E", ALPHANUMERIC_LENGTH_4UHV, w_val);
		newvalue = string(buffer, len);
	}

	switch (indexn)
	{
		case 1:
			write("615", newvalue);
			break;
		case 2:
			write("625", newvalue);
			break;
		case 3:
			write("635", newvalue);
			break;
		case 4:
			write("645", newvalue);
			break;
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_SetPointX
}
//--------------------------------------------------------
/**
 *	Read attribute TemperatureHVX related method
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_TemperatureHVX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_TemperatureHVX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevFloat	*att_value = get_TemperatureHVX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_TemperatureHVX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_TemperatureHVX
}
//--------------------------------------------------------
/**
 *	Read attribute VoltageX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_VoltageX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_VoltageX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_VoltageX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_VoltageX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_VoltageX
}
//--------------------------------------------------------
/**
 *	Read attribute CurrentX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_CurrentX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_CurrentX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_CurrentX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_CurrentX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_CurrentX
}
//--------------------------------------------------------
/**
 *	Read attribute PressureX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_PressureX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_PressureX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_PressureX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_PressureX) ENABLED START -----*/
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_PressureX
}
//--------------------------------------------------------
/**
 *	Read attribute StateX related method
 *	Description: 
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StateX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StateX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevState	*att_value = get_StateX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StateX) ENABLED START -----*/
	//	Set the attribute value

	string indexs = attr.get_name().substr(attr.get_name().size()-1);
	int indexn;
	convert(indexs, indexn);

	if (errorcode[indexn-1] != 0) {
		*att_value = Tango::FAULT;
	} else {
		*att_value = HVX_data["HV" + indexs];
	}

	attr.set_value(att_value);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StateX
}
//--------------------------------------------------------
/**
 *	Read attribute StatusX related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StatusX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StatusX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevString	*att_value = get_StatusX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StatusX) ENABLED START -----*/
	//	Set the attribute value

	string indexs = attr.get_name().substr(attr.get_name().size()-1);
	int indexn;	
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	string status;
	if (HVX_data["HV" + indexs] == Tango::ON)
		status = "The device is in ON state";
	else
		status = "The device is in OFF state";
	
	int err = errorcode[indexn-1];
	if (err != 0)
	{
		status = "";

		if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
			if (err & 0x4)
				status += "Over Temperature ";
			if (err & 0x20)
				status += "Interlock cable ";
			if (err & 0x40)
				status += "ShortCircuit ";
			if (err & 0x80)
				status += "Protect ";
		} else {
			if (err & 0x1)
				status += "FAN error ";
			if (err & 0x2)
				status += "Power input error from HV ";
			if (err & 0x4)
				status += "Power input error from PFC ";
			if (err & 0x8)
				status += "Overtemp PFC ";
			if (err & 0x10)
				status += "Error communication CPU-HV ";
			if (err & 0x20)
				status += "Interlock cable ";
			if (err & 0x40)
				status += "Overtemp HV ";
			if (err & 0x80)
				status += "Protect ";
			if (err & 0x100)
				status += "Measurement error ";
			if (err & 0x200)
				status += "HV out error ";
			if (err & 0x400)
				status += "Short circuit ";
			if (err & 0x800)
				status += "HV disabled ";
		}

	}

	if (*att_value != NULL)
		CORBA::string_free(*att_value);
	*att_value = CORBA::string_dup(status.c_str());

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StatusX
}
//--------------------------------------------------------
/**
 *	Read attribute ProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_ProtectX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_ProtectX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_ProtectX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_ProtectX) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(att_value);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_ProtectX
}
//--------------------------------------------------------
/**
 *	Write attribute ProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_ProtectX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_ProtectX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_ProtectX) ENABLED START -----*/

	check_init_error();

	int indexn;	
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	string newvalue;
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		if (w_val)
			newvalue = "1";
		else
			newvalue = "0";
	} else {
		read_Protect();
		newvalue = "0000000000";
		for(int i=1; i<5; ++i) {
			if (i == indexn) {
				if (w_val)
					newvalue[10-i] = '1';
				else
					newvalue[10-i] = '0';
			} else {
				stringstream ss;
				ss << i;
				if (ProtectX_data["Protect" + ss.str()])
					newvalue[10-i] = '1';
				else
					newvalue[10-i] = '0';
			}
		}
	}

	write("602", newvalue);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_ProtectX
}
//--------------------------------------------------------
/**
 *	Read attribute FixedStepX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_FixedStepX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_FixedStepX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_FixedStepX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_FixedStepX) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(att_value);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_FixedStepX
}
//--------------------------------------------------------
/**
 *	Write attribute FixedStepX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_FixedStepX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_FixedStepX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_FixedStepX) ENABLED START -----*/

	check_init_error();

	int indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);	

	string newvalue;
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		if (w_val)
			newvalue = "1";
		else
			newvalue = "0";
	} else {
		read_FixedStep();
		newvalue = "0000000000";
		for(int i=1; i<5; ++i) {
			if (i == indexn) {
				if (w_val)
					newvalue[10-i] = '1';
				else
					newvalue[10-i] = '0';
			} else {
				stringstream ss;
				ss << i;
				if (FixedStepX_data["Fixed" + ss.str()])
					newvalue[10-i] = '1';
				else
					newvalue[10-i] = '0';
			}
		}
	}

	write("603", newvalue);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_FixedStepX
}
//--------------------------------------------------------
/**
 *	Read attribute StatusSetPointX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StatusSetPointX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StatusSetPointX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_StatusSetPointX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StatusSetPointX) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(att_value);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StatusSetPointX
}
//--------------------------------------------------------
/**
 *	Read attribute StatMaskX related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StatMaskX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StatMaskX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevLong	*att_value = get_StatMaskX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StatMaskX) ENABLED START -----*/
	//	Set the attribute value

	string indexs = attr.get_name().substr(attr.get_name().size()-1);
	int indexn;
	convert(indexs, indexn);

	*att_value = 0;

	if (HVX_data["HV" + indexs])
		*att_value |= 0x1;

	// FIXME How provides locale/remote bit (1)?
	*att_value |= 0x1 << 1;

	if (errorcode[indexn-1] != 0)
		*att_value |= 0x1 << 2;

	if (FixedStepX_data["Fixed" + indexs] == true)
		*att_value |= 0x1 << 3;

	// FIXME bit 4,5,6 and 7 aren't implemented

	attr.set_value(att_value);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StatMaskX
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Agilent4uhv::add_dynamic_attributes()
{
	//	Example to add dynamic attribute:
	//	Copy inside the following protected area to create instance(s) at startup.
	//	add_HVX_dynamic_attribute("MyHVXAttribute");
	//	add_DeviceNumberX_dynamic_attribute("MyDeviceNumberXAttribute");
	//	add_PowerMaxX_dynamic_attribute("MyPowerMaxXAttribute");
	//	add_VTargetX_dynamic_attribute("MyVTargetXAttribute");
	//	add_IProtectX_dynamic_attribute("MyIProtectXAttribute");
	//	add_SetPointX_dynamic_attribute("MySetPointXAttribute");
	//	add_TemperatureHVX_dynamic_attribute("MyTemperatureHVXAttribute");
	//	add_VoltageX_dynamic_attribute("MyVoltageXAttribute");
	//	add_CurrentX_dynamic_attribute("MyCurrentXAttribute");
	//	add_PressureX_dynamic_attribute("MyPressureXAttribute");
	//	add_StateX_dynamic_attribute("MyStateXAttribute");
	//	add_StatusX_dynamic_attribute("MyStatusXAttribute");
	//	add_ProtectX_dynamic_attribute("MyProtectXAttribute");
	//	add_FixedStepX_dynamic_attribute("MyFixedStepXAttribute");
	//	add_StatusSetPointX_dynamic_attribute("MyStatusSetPointXAttribute");
	//	add_StatMaskX_dynamic_attribute("MyStatMaskXAttribute");
	
	/*----- PROTECTED REGION ID(Agilent4uhv::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	for (unsigned short i=1; i <= nchannel; ++i)
	{
		stringstream ssname;
		string sname;

		if (odd_channel_quirk && i > 1)
			++i;
		ssname.str(""); ssname.clear();
		ssname << "HV" << i << flush;
		sname = ssname.str();
		add_HVX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "DeviceNumber" << i << flush;
		sname = ssname.str();
		add_DeviceNumberX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "PowerMax" << i << flush;
		sname = ssname.str();
		add_PowerMaxX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "VTarget" << i << flush;
		sname = ssname.str();
		add_VTargetX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "IProtect" << i << flush;
		sname = ssname.str();
		add_IProtectX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "SetPoint" << i << flush;
		sname = ssname.str();
		add_SetPointX_dynamic_attribute(sname);
		
		ssname.str(""); ssname.clear();
		ssname << "TemperatureHV" << i << flush;
		sname = ssname.str();
		add_TemperatureHVX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Voltage" << i << flush;
		sname = ssname.str();
		add_VoltageX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Current" << i << flush;
		sname = ssname.str();
		add_CurrentX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Pressure" << i << flush;
		sname = ssname.str();
		add_PressureX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "State" << i << flush;
		sname = ssname.str();
		add_StateX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Status" << i << flush;
		sname = ssname.str();
		add_StatusX_dynamic_attribute(sname);
		Tango::DevString *att_value = get_StatusX_data_ptr(sname);
		*att_value = NULL; 

		ssname.str(""); ssname.clear();
		ssname << "Protect" << i << flush;
		sname = ssname.str();
		add_ProtectX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Fixed" << i << flush;
		sname = ssname.str();
		add_FixedStepX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "StatusSetPoint" << i << flush;
		sname = ssname.str();
		add_StatusSetPointX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "StatMask" << i << flush;
		sname = ssname.str();
		add_StatMaskX_dynamic_attribute(sname);
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command OnHVX related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::on_hvx(Tango::Command &command)
{
	DEBUG_STREAM << "Agilent4uhv::" << command.get_name() << "  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::on_hvx) ENABLED START -----*/
	
	//	Add your own code
 	check_init_error();
	
	int indexn;
	convert(command.get_name().substr(command.get_name().size()-1), indexn);

 	bool new_state = true;
	switch(indexn) {
		case 1:
 			write("011", new_state);	
			break;
		case 2:
 			write("012", new_state);	
			break;
		case 3:
 			write("013", new_state);	
			break;
		case 4:
			write("014", new_state);	
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::on_hvx
}
//--------------------------------------------------------
/**
 *	Command OffHVX related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::off_hvx(Tango::Command &command)
{
	DEBUG_STREAM << "Agilent4uhv::" << command.get_name() << "  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::off_hvx) ENABLED START -----*/
	
	//	Add your own code
 	check_init_error();
	
	int indexn;
	convert(command.get_name().substr(command.get_name().size()-1), indexn);

 	bool new_state = false;
	switch(indexn) {
		case 1:
			write("011", new_state);	
			break;
		case 2:
			write("012", new_state);	
			break;
		case 3:
			write("013", new_state);	
			break;
		case 4:
			write("014", new_state);	
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::off_hvx
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Agilent4uhv::add_dynamic_commands()
{
	//	Example to add dynamic command:
	//	Copy inside the folowing protected area to instanciate at startup.
	//	add_OnHVX_dynamic_command("MyOnHVXCommand", true);
	//	add_OffHVX_dynamic_command("MyOffHVXCommand", true);
	
	/*----- PROTECTED REGION ID(Agilent4uhv::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	for (unsigned short i=1; i <= nchannel; ++i) {
		if (odd_channel_quirk && i > 1)
			++i;

		stringstream ss;
		ss << i;
		add_OnHVX_dynamic_command("OnHV" + ss.str(), true);
		add_OffHVX_dynamic_command("OffHV" + ss.str(), true);
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Agilent4uhv::namespace_ending) ENABLED START -----*/

//	Additional Methods
#define CRC_LENGTH 2

#define READ_WINDOW 0x30
#define WRITE_WINDOW 0x31

struct MessageHeader {
	unsigned char stx;
	unsigned char addr;
	char win[WIN_LENGTH];
	unsigned char com;
};

struct MessageFooter {
	unsigned char etx;
	unsigned char crc[CRC_LENGTH];
};

struct ResponseHeader {
	unsigned char stx;
	unsigned char addr;
	unsigned char ack;
};


void Agilent4uhv::write_message(const char window[WIN_LENGTH],
		const unsigned char com, const char * const data,
		const size_t data_length)
{
	vector<unsigned char> message(sizeof(MessageHeader) +
			data_length + sizeof(MessageFooter));

	MessageHeader *header = (MessageHeader*)&message[0];
	MessageFooter *footer = (MessageFooter*)(&message[0]
			+ sizeof(MessageHeader) + data_length);

	header->stx = 0x02;
	header->addr = 0x80;
	memcpy(header->win, window, WIN_LENGTH);
	header->com = com;

	memcpy(&message[0] + sizeof(MessageHeader),
			data, data_length);

	footer->etx = 0x03;

	char crc_with_term[CRC_LENGTH+1];
	snprintf(crc_with_term, CRC_LENGTH+1, "%02X",
			calc_crc(&message[1] /* Skip STX */,
				sizeof(MessageHeader) + data_length));
	memcpy(footer->crc, crc_with_term, CRC_LENGTH);

	Serial2Client::write(message);
}

string Agilent4uhv::read_answer()
{
	vector<unsigned char> answer, crc;
	size_t data_length;
	string ret;

	Serial2Client::read_until(0x03, answer);
	Serial2Client::read(2, crc);
	
	data_length = answer.size() - sizeof(MessageHeader) - 1 /* Skip ETX */;

	char expected_crc[CRC_LENGTH+1];
	snprintf(expected_crc, CRC_LENGTH+1, "%02X",
			calc_crc(&answer[1] /* Skip STX */,
				answer.size()-1 /* Skip ETX */));

	if(memcmp(&crc[0], expected_crc, CRC_LENGTH) != 0) {
		attr_CRCErrors_read[0]++;
		Tango::Except::throw_exception( "",
				"CRC check failed",
				"Agilent4uhv::read_answer()");
	}

	if (answer.size() == 4) {
		ResponseHeader *header = (ResponseHeader*)&answer[0];
		
		string err_mesg;
		switch ((int)header->ack)
		{
			case 0x06: /* ACK */
				break;
			case 0x15: /* NACK */
				err_mesg = "Execution of the command has failed";
				break;
			case 0x32: /* Unknown Window */
				err_mesg = "The window specified in the command"
					" is not a valid window";
				break;
			case 0x33: /* Data Type Error */
				err_mesg = "The data type specified in the command"
					" (Logic, Numeric or Alphanumeric) is not"
					" in agreement with the Window specified";
				break;
			case 0x35: /* Win Disabled */
				err_mesg = "The window specified is Read Only or"
					" is temporarily disabled";
				break;
			default:
				// "Out of Range" perhaps?
				err_mesg = "Unknown error";
				break;
		}

		if (! err_mesg.empty())
			Tango::Except::throw_exception( "",
					err_mesg,
					"Agilent4uhv::read_answer()");
	} else {
		ret = string((char*)(&answer[0] + sizeof(MessageHeader)), data_length);
	}
	return ret;
}

string Agilent4uhv::read(const char window[WIN_LENGTH])
{
	omni_mutex_lock l(io_mutex);
	try {
		write_message(window, READ_WINDOW, NULL, 0);
		return read_answer();
	} catch(...) {
		throw;
	}
}

void Agilent4uhv::write(const char window[WIN_LENGTH], const char * const data,
		const size_t data_length)
{
	omni_mutex_lock l(io_mutex);
	try {
		write_message(window, WRITE_WINDOW, data, data_length);
		(void)read_answer();
	} catch(...) {
		throw;
	}
}

int Agilent4uhv::calc_crc(unsigned char *contents, size_t count)
{
	int ret = 0;
	for (size_t i = 0; i < count; ++i)
		ret ^= contents[i];
	return ret;
}

void Agilent4uhv::check_init_error(void)
{
	if (! init_error.empty())
		Tango::Except::throw_exception( "",
			init_error.c_str(),
			"Agilent4uhv::check_init_error()");
}

void Agilent4uhv::read(const char window[WIN_LENGTH], string &data) {
	data = read(window);
}

void Agilent4uhv::read(const char window[WIN_LENGTH], bool &data) {
	string tmp = read(window);
	convert(tmp, data);
}

void Agilent4uhv::read(const char window[WIN_LENGTH], int &data) {
	string tmp = read(window);
	convert(tmp, data);
}

void Agilent4uhv::write(const char window[WIN_LENGTH], const string &data) {
	if (strcmp(attr_Model_read[0], "X3602-64010") == 0) {
		write(window, data.c_str(), ALPHANUMERIC_LENGTH_IPCMINI > data.size()?
				data.size() : ALPHANUMERIC_LENGTH_IPCMINI);
	} else {
		write(window, data.c_str(), ALPHANUMERIC_LENGTH_4UHV > data.size()?
				data.size() : ALPHANUMERIC_LENGTH_4UHV);
	}
}

void Agilent4uhv::write(const char window[WIN_LENGTH], const bool data) {
	char data_[LOGIC_LENGTH+1];
	snprintf(data_, LOGIC_LENGTH+1, "%0*d", LOGIC_LENGTH, data);
	write(window, data_, LOGIC_LENGTH);
}

void Agilent4uhv::write(const char window[WIN_LENGTH], const int data) {
	char data_[NUMERIC_LENGTH+1];
	snprintf(data_, NUMERIC_LENGTH+1, "%0*d", NUMERIC_LENGTH, data);
	write(window, data_, NUMERIC_LENGTH);
}

void Agilent4uhv::read_Status() {
	int val;
	read("205", val);

	if (val == 0) {
		set_state(Tango::ON);
		set_status("The device is in ON state");
	} else {
		set_state(Tango::FAULT);
		set_status("The device is in FAULT state");
	}
}

void Agilent4uhv::read_Model() {
	string val;
	read("319", val);
	strncpy(attr_Model_read[0], val.c_str(),
			MAX_DEVSTRING_LENGTH > val.size()?
			val.size() : MAX_DEVSTRING_LENGTH);
}

void Agilent4uhv::read_PowerMaxCh1() {
	int val;
	read("612", val);
	PowerMaxX_data["PowerMax1"] = val;
}

void Agilent4uhv::read_PowerMaxCh2() {
	int val;
	read("622", val);
	PowerMaxX_data["PowerMax2"] = val;
}

void Agilent4uhv::read_PowerMaxCh3() {
	int val;
	read("632", val);
	PowerMaxX_data["PowerMax3"] = val;
}

void Agilent4uhv::read_PowerMaxCh4() {
	int val;
	read("642", val);
	PowerMaxX_data["PowerMax4"] = val;
}

void Agilent4uhv::read_PressureCh1() {
	string val;
	read("812", val);
	double val2;
	convert(val, val2); 
	PressureX_data["Pressure1"] = val2;
}

void Agilent4uhv::read_PressureCh2() {
	string val;
	read("822", val);
	double val2;
	convert(val, val2); 
	PressureX_data["Pressure2"] = val2;
}

void Agilent4uhv::read_PressureCh3() {
	string val;
	read("832", val);
	double val2;
	convert(val, val2); 
	PressureX_data["Pressure3"] = val2;
}

void Agilent4uhv::read_PressureCh4() {
	string val;
	read("842", val);
	double val2;
	convert(val, val2); 
	PressureX_data["Pressure4"] = val2;
}

void Agilent4uhv::read_HVCh1() {
	bool val;
	read("011", val);
	
	if (val)
		HVX_data["HV1"] = Tango::ON;
	else
		HVX_data["HV1"] = Tango::OFF;
}

void Agilent4uhv::read_HVCh2() {
	bool val;
	read("012", val);
	
	if (val)
		HVX_data["HV2"] = Tango::ON;
	else
		HVX_data["HV2"] = Tango::OFF;
}

void Agilent4uhv::read_HVCh3() {
	bool val;
	read("013", val);
	
	if (val)
		HVX_data["HV3"] = Tango::ON;
	else
		HVX_data["HV3"] = Tango::OFF;
}

void Agilent4uhv::read_HVCh4() {
	bool val;
	read("014", val);
	
	if (val)
		HVX_data["HV4"] = Tango::ON;
	else
		HVX_data["HV4"] = Tango::OFF;
}

void Agilent4uhv::read_ErrorCodeCh1() {
	int val;
	if (nchannel > 1)
		write("505", 1);
	read("206", val);
	errorcode[0] = val;
}

void Agilent4uhv::read_ErrorCodeCh2() {
	int val;
	write("505", 2);
	read("206", val);
	errorcode[1] = val;
}

void Agilent4uhv::read_ErrorCodeCh3() {
	int val;
	write("505", 3);
	read("206", val);
	errorcode[2] = val;
}

void Agilent4uhv::read_ErrorCodeCh4() {
	int val;
	write("505", 4);
	read("206", val);
	errorcode[3] = val;
}

void Agilent4uhv::read_SerialNumber() {
	string val;
	read("323", val);
	strncpy(attr_SerialNumber_read[0], val.c_str(),
			MAX_DEVSTRING_LENGTH > val.size()?
			val.size() : MAX_DEVSTRING_LENGTH);
}

void Agilent4uhv::read_FixedStep() {
	string val;
	read("603", val);
	
	if (val.size() == 1) {
		if (val[0] == '0') {
			FixedStepX_data["Fixed1"] = false;
		} else {
			FixedStepX_data["Fixed1"] = true;
		}
	} else {
		int j = 1;
		for (int i = val.size(); i > ((int)val.size() - 4) /* Max channels */; --i) {
			stringstream ss;
			ss << j++;
			if (val[i-1] == '0') {
				FixedStepX_data["Fixed" + ss.str()] = false;
			} else {
				FixedStepX_data["Fixed" + ss.str()] = true;
			}
		}
	}
}

void Agilent4uhv::read_AutoStart() {
	string val;
	read("601", val);
	
	if (val[val.size()-1] == '1') {
		attr_AutoStart_read[0] = true;
	} else {
		attr_AutoStart_read[0] = false;
	}
}

void Agilent4uhv::read_Protect() {
	string val;
	read("602", val);
	
	if (val.size() == 1) {
		if (val[0] == '0') {
			ProtectX_data["Protect1"] = false;
		} else {
			ProtectX_data["Protect1"] = true;
		}
	} else {
		int j = 1;
		for (int i = val.size(); i > ((int)val.size() - 4) /* Max channels */; --i) {
			stringstream ss;
			ss << j++;
			if (val[i-1] == '0') {
				ProtectX_data["Protect" + ss.str()] = false;
			} else {
				ProtectX_data["Protect" + ss.str()] = true;
			}
		}
	}
}

void Agilent4uhv::read_StatusSetPoint() {
	string val;
	read("804", val);

	if (val.size() == 1) {
		if (val[0] == '0') {
			StatusSetPointX_data["StatusSetPoint1"] = false;
		} else {
			StatusSetPointX_data["StatusSetPoint1"] = true;
		}
	} else {
		int j = 1;
		for (int i = val.size(); i > ((int)val.size() - 4) /* Max channels */; --i) {
			stringstream ss;
			ss << j++;
			if (val[i-1] == '0') {
				StatusSetPointX_data["StatusSetPoint" + ss.str()] = false;
			} else {
				StatusSetPointX_data["StatusSetPoint" + ss.str()] = true;
			}
		}
	}
}

void Agilent4uhv::read_DeviceNumberCh1() {
	int val;
	read("610", val);
	DeviceNumberX_data["DeviceNumber1"] = val;
}

void Agilent4uhv::read_DeviceNumberCh2() {
	int val;
	read("620", val);
	DeviceNumberX_data["DeviceNumber2"] = val;
}

void Agilent4uhv::read_DeviceNumberCh3() {
	int val;
	read("630", val);
	DeviceNumberX_data["DeviceNumber3"] = val;
}

void Agilent4uhv::read_DeviceNumberCh4() {
	int val;
	read("640", val);
	DeviceNumberX_data["DeviceNumber4"] = val;
}

void Agilent4uhv::read_VTargetCh1() {
	int val;
	read("613", val);
	VTargetX_data["VTarget1"] = val / 1000;
}

void Agilent4uhv::read_VTargetCh2() {
	int val;
	read("623", val);
	VTargetX_data["VTarget2"] = val / 1000;
}

void Agilent4uhv::read_VTargetCh3() {
	int val;
	read("633", val);
	VTargetX_data["VTarget3"] = val / 1000;
}

void Agilent4uhv::read_VTargetCh4() {
	int val;
	read("643", val);
	VTargetX_data["VTarget4"] = val / 1000;
}

void Agilent4uhv::read_IProtectCh1() {
	int val;
	read("614", val);
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		IProtectX_data["IProtect1"] = val / 1000;
	} else {
		IProtectX_data["IProtect1"] = val;
	}
}

void Agilent4uhv::read_IProtectCh2() {
	int val;
	read("624", val);
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		IProtectX_data["IProtect2"] = val / 1000;
	} else {
		IProtectX_data["IProtect2"] = val;
	}
}

void Agilent4uhv::read_IProtectCh3() {
	int val;
	read("634", val);
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		IProtectX_data["IProtect3"] = val / 1000;
	} else {
		IProtectX_data["IProtect3"] = val;
	}
}

void Agilent4uhv::read_IProtectCh4() {
	int val;
	read("644", val);
	if (strncmp(attr_Model_read[0], "X3602-64010", 11) == 0) {
		IProtectX_data["IProtect4"] = val / 1000;
	} else {
		IProtectX_data["IProtect4"] = val;
	}
}

void Agilent4uhv::read_SetPointCh1() {
	string val;
	read("615", val);
	convert(val, SetPointX_data["SetPoint1"]);
}

void Agilent4uhv::read_SetPointCh2() {
	string val;
	read("625", val);
	convert(val, SetPointX_data["SetPoint2"]);
}

void Agilent4uhv::read_SetPointCh3() {
	string val;
	read("635", val);
	convert(val, SetPointX_data["SetPoint3"]);
}

void Agilent4uhv::read_SetPointCh4() {
	string val;
	read("645", val);
	convert(val, SetPointX_data["SetPoint4"]);
}

void Agilent4uhv::read_Temperature() {
	int val;
	read("800", val);
	attr_Temperature_read[0] = val;
}

void Agilent4uhv::read_TemperatureCh1() {
	int val;
	read("801", val);
	TemperatureHVX_data["TemperatureHV1"] = val;
}

void Agilent4uhv::read_TemperatureCh2() {
	int val;
	read("802", val);
	TemperatureHVX_data["TemperatureHV2"] = val;
}

void Agilent4uhv::read_TemperatureCh3() {
	int val;
	read("808", val);
	TemperatureHVX_data["TemperatureHV3"] = val;
}

void Agilent4uhv::read_TemperatureCh4() {
	int val;
	read("809", val);
	TemperatureHVX_data["TemperatureHV4"] = val;
}

void Agilent4uhv::read_IMeasuredCh1() {
	string val;
	read("811", val);
	convert(val, CurrentX_data["Current1"]);
}

void Agilent4uhv::read_IMeasuredCh2() {
	string val;
	read("821", val);
	convert(val, CurrentX_data["Current2"]);
}

void Agilent4uhv::read_IMeasuredCh3() {
	string val;
	read("831", val);
	convert(val, CurrentX_data["Current3"]);
}

void Agilent4uhv::read_IMeasuredCh4() {
	string val;
	read("841", val);
	convert(val, CurrentX_data["Current4"]);
}

void Agilent4uhv::read_VMeasuredCh1() {
	int val;
	read("810", val);
	VoltageX_data["Voltage1"] = val;
}

void Agilent4uhv::read_VMeasuredCh2() {
	int val;
	read("820", val);
	VoltageX_data["Voltage2"] = val;
}

void Agilent4uhv::read_VMeasuredCh3() {
	int val;
	read("830", val);
	VoltageX_data["Voltage3"] = val;
}

void Agilent4uhv::read_VMeasuredCh4() {
	int val;
	read("840", val);
	VoltageX_data["Voltage4"] = val;
}

void* Agilent4uhvWorker::run_undetached(void * /*ptr*/)
{
	DEBUG_STREAM << "Agilent4uhvWorker::run_undetached() - enter" << endl;

	string error;
	vector<ptrFunction>::iterator norm_it = device->norm_ops.begin();
	vector<ptrFunction>::iterator prio_it = device->prio_ops.begin();

	while(cont) {
		try {
			error.clear();

			// Retrieve priority data
			(device->*(*prio_it))();
			if(++prio_it == device->prio_ops.end())
				prio_it = device->prio_ops.begin();
			
			// A chance to exit from while loop
			if(! cont)
				break;

			usleep(device->pollingPause * 1000);

			// A chance to exit from while loop
			if(! cont)
				break;
			
			// Retrieve normal data
			(device->*(*norm_it))();
			if(++norm_it == device->norm_ops.end())
				norm_it = device->norm_ops.begin();
		
			// A chance to exit from while loop
			if(! cont)
				break;

			usleep(device->pollingPause * 1000);
		} catch(Tango::DevFailed &e) {
			error = string(e.errors[0].desc);
		} catch(...) {
			error = "Unknown error";
		}

		if(! error.empty()) {
			ERROR_STREAM << error << endl;
			device->set_state(Tango::UNKNOWN);
			device->set_status(error);
			assert(false);
		}
			
		usleep(device->pollingPeriod * 1000);
	}

	DEBUG_STREAM << "Agilent4uhvWorker::run_undetached() - exit" << endl;

	return NULL;
}

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::namespace_ending
} //	namespace
