static const char *RcsId = "$Id: MultiClassesFactory.cpp,v 1.7 2019-01-18 09:31:15 alessio Exp $";
//=============================================================================
//
// file :        MultiClassessFactory.cpp
//
// description : C++ source for the class_factory method of the DServer
//               device class. This method is responsible for the creation of
//               all class singleton for a device server. It is called
//               at device server startup.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.7 $
// $Date: 2019-01-18 09:31:15 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <tango.h>
#include <Socket2Class.h>
#include <Serial2Class.h>
#include <Agilent4uhvClass.h>
#include <IonpumpClass.h>

/**
 *	Create Class singletons and store them in DServer object.
 */

void Tango::DServer::class_factory()
{
	add_class(Socket2_ns::Socket2Class::init("Socket2"));
	add_class(Serial2_ns::Serial2Class::init("Serial2"));
	add_class(Agilent4uhv_ns::Agilent4uhvClass::init("Agilent4uhv"));
	add_class(Ionpump_ns::IonpumpClass::init("Ionpump"));
}
